# Datei, die kompiliert werden soll (ohne Endung)
BINARY := nacl

# Header Datei, in der alle notwendigen Numerik Funktionen sind
HEADER := my_numerics

# Argumente, mit dem das Programm ausgeführt wird,
ARGS   :=

# Der zu verwendende C Compiler
CC     := gcc

# Flags, die für das Kompilieren benötigt werden (03 für effizient, lm für math Bibliotheken)LAPACK
CFLAGS := -O3 -lm 

# Flags, die zum Debugging benötigt werden
DFLAGS := -Wall -Wextra -Wshadow -pedantic -fstack-protector

# Flags, die für das linken von .o Dateien benötigt werden
LFLAGS := -flto #-llapacke -lblas

#-----------------------
# Benutzung:
#-----------------------
# make  	-> Nur kompilieren
# make run 	-> Kompilieren und ausführen
# make plot -> Ausführen von Pythonskripten
# make clean-> Nicht notwendige Dateien löschen

# Kompilierung der Zieldatei, Verlinkung mit der Headerdatei
$(BINARY): $(BINARY).c $(HEADER).c $(HEADER).o
	gcc $(LFLAGS) -o $(BINARY) $(BINARY).c $(HEADER).o $(DFLAGS) $(CFLAGS)


# Kompilierung der Headerdatei
$(HEADER).o: $(HEADER).c  $(HEADER).h
	gcc -c $(HEADER).c -o $(HEADER).o $(DFLAGS) $(CFLAGS)

# Wenn das Programm existiert, führe es aus, wenn nicht kompiliere und führe es dann aus
run: $(BINARY)
	./$< $(ARGS)

# Führe Programm aus und danach sofort das angegebene Python Script
plot:
	python3 $(BINARY).py

# Entfernen von temporären und nicht notwendigen Dateien
clean:
	rm -f *.o
	rm -f $(HEADER).o
	rm -f *.exe
	rm -f $(BINARY)
	rm -f *.dat *.csv *.txt
